// C Header File
// Created 2001-06-27; 18:22:09
//Mostly written and commented by Jon Eriksson
#define RIGHT 1
#define LEFT 2
#define UP 3
#define DOWN 4
#define ARROWS_ROW 0xfffe      // Constants for low-level keyboard access
#define LEFT_KEY 2
#define RIGHT_KEY 8
#define UP_KEY 1
#define DOWN_KEY 4
#define ENTER_ROW ~((short)(1 << 1))
#define ENTER_KEY (1 << 0)

long int timer;
long int tkeep;
int tk;
void delay(void) {
	short int loop = 200, randNum;
	
	// generate random numbers to slow down the program...
	while (loop-- > 0) {
		randNum = rand() % loop;
	}
	timer++;
}

int Game (void)
{
	int key=0,check_esc=0,check_f1=0,check_f5=0;
	int dir=RIGHT;
	int temp,jumpflag=1;
	int quit=0;
	int blocks=0;
	int map_height=23;
	long int player_x_update=0;
	long int player_y_update=0;
	long int pblock_init=0;
	long int monster_update=0;

	int dead=FALSE;

//	static unsigned char placeable_block[] = {0x7E,0x81,0xB1,0xA1,0x81,0x81,0x81,0x7E};

static unsigned char placeable_block_light[]={0x7E,0x81,0xBD,0xA5,0xA5,0xBD,0x81,0x7E}; //2
static unsigned char placeable_block_dark[]={0x7E,0xFF,0xC3,0xC3,0xC3,0xC3,0xFF,0x7E}; 

	static unsigned char player_left_dark[] = 
		{0x7C,0x62,0x4A,0xC9,0xA2,0x9C,0x3C,0x76,0x76,0xFB,0xFF,0xFE,0x38,0x38,0x3C,0x3C};
	static unsigned char player_left_light[] = 
		{0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x76,0x76,0xFB,0xFF,0xFE,0x00,0x00,0x00,0x00};
	static unsigned char player_right_dark[] = 
		{0x3E,0x46,0x52,0x93,0x45,0x39,0x3C,0x6E,0x6E,0xDF,0xFF,0x7F,0x1C,0x1C,0x3C,0x3C};
	static unsigned char player_right_light[] = 
		{0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x6E,0x6E,0xDF,0xFF,0x7F,0x00,0x00,0x00,0x00};



ClearGrayScreen();
	
  player_x=9;
  player_y=80;
	player_x_speed=0;  // + = right, - = left movement
	player_y_speed=0;
	timer=0;
	tkeep=0;
	tk=0;
	monster_count=0;

// Let the map_engine do it's work!
	ClrScr();
	draw_map(map_height);
	
// Time to place the player ;)
	Sprite8_XOR(player_x, player_y, 16, player_left_dark, GetPlane (DARK_PLANE));
	Sprite8_XOR(player_x, player_y, 16, player_left_light, GetPlane (LIGHT_PLANE));
	Draw_HUD(blocks);
	
while (quit==0) {

	// This while function will be used when the player doesn't hit any key, whitch
	// basicly will be used for the Physic engine, whitch will keep track of the player Y and X speeds
		// Remove
		if (dir==1) {
			Sprite8_XOR(player_x, player_y, 16, player_left_dark, GetPlane (DARK_PLANE));
			Sprite8_XOR(player_x, player_y, 16, player_left_light, GetPlane (LIGHT_PLANE));		
		}
		if (dir==2) {
			Sprite8_XOR(player_x, player_y, 16, player_right_dark, GetPlane (DARK_PLANE));
			Sprite8_XOR(player_x, player_y, 16, player_right_light, GetPlane (LIGHT_PLANE));		
		}
		if (player_x_update<timer) player_x_update=timer+update_player_x();
		if (player_y_update<timer) player_y_update=timer+update_player_y();
		
		if ((!On_Ground()) && (player_y_speed==0)) player_y_update=timer+update_player_y();
				
		if (player_y<30 && map_height>0) {
			draw_map(map_height); // this should erase the map
			map_height-=5;
			temp=0;
			if (map_height<=0) {
				temp=map_height;
				map_height=0;
							} 
			ai_follow_scroll(DOWN,temp+5);
			draw_map(map_height);
			player_y+=40+(temp*8);	
			Draw_HUD(blocks);
		}

	// But... But... What about if the player falls down?.. 
	// Allright.. let's sort this out as well
		if (player_y>84) {  // 128-player_height=112..
			draw_map(map_height); // this should erase the map
			map_height+=5;
			temp=0;
			if(map_height>23){temp=23-map_height;map_height=23;}
			ai_follow_scroll(UP,temp+5);
			draw_map(map_height);
			player_y-=40;
			Draw_HUD(blocks);
		}
		// Place back
		if (dir==1) {
			Sprite8_XOR(player_x, player_y, 16, player_left_dark, GetPlane (DARK_PLANE));
			Sprite8_XOR(player_x, player_y, 16, player_left_light, GetPlane (LIGHT_PLANE));		
		}
		if (dir==2) {
			Sprite8_XOR(player_x, player_y, 16, player_right_dark, GetPlane (DARK_PLANE));
			Sprite8_XOR(player_x, player_y, 16, player_right_light, GetPlane (LIGHT_PLANE));		
		}
	
		// Run the monsters! *Iiiiihaaaa!!!!* AI function's that is ;D
		// But first.. let's do a check so we have monsters visable..
		if (monster_count>0)
		{
			if (monster_update<timer) {
				run_monsters(); // Located in the ai.h file
				monster_update=timer+7;
			}
			dead=check_ai_touch(player_x,player_y);
	
			if (dead) {
				youdied(1);
				lives--;
				if (lives==0) return 9;
				return 5;
			}
		}
	
		delay();
	
		if (timer>tkeep) {
			tkeep=timer+(140*hardness);
			tk++;
			DrawGrayLine(90,2,90+tk,2,COLOR_BLACK);
			DrawGrayLine(90,3,90+tk,3,COLOR_BLACK);
			if ((90+tk)>140) {
				youdied(0);
				lives--;
				if (lives==0) return 9;
				return 5;	
			}
		}



		key=0;
	// We finaly got ourself togeather, and it's now time for the Scrolling of the screen in case
	// the player climbs to high ;)
		// Now it's time to give a check if we've finished the track!
		if (player_y<16) {
			/* Oh yeah, we've done it!
				 10 Salutes for me! ;D
				 Oh well.. Prepare for another level.. sorta..*/ 

			SetPlane(LIGHT_PLANE);
			ScrRectFill (&(SCR_RECT){{80, 20, 160, 80}}, ScrRect, A_REVERSE);
			DrawLine(80,20,160,20,A_NORMAL);
			DrawLine(80,80,160,80,A_NORMAL);
			DrawLine(80,20,80,80,A_NORMAL);
			DrawLine(159,20,159,80,A_NORMAL);
			SetPlane(DARK_PLANE);
			ScrRectFill (&(SCR_RECT){{80, 20, 160, 80}}, ScrRect, A_REVERSE);
			DrawLine(80,20,160,20,A_NORMAL);
			DrawLine(80,80,160,80,A_NORMAL);
			DrawLine(80,20,80,80,A_NORMAL);
			DrawLine(159,20,159,80,A_NORMAL);
			
			FontSetSys(F_4x6);
		  printf_xy(85, 47, "CONGRATULATIONS!");

			player_y=16;
			lives++;
congrats();
			printf_xy(85, 67, "Press Enter...");
			while (!(_rowread(ENTER_ROW) & ENTER_KEY)) { };
		  ClearGrayScreen();
		  return 2;
		}

	key = _rowread(ARROWS_ROW);
	check_esc = _rowread(0xFFBF); //~((short)(1 << 6)
	check_f1 = _rowread(~((short)(1 << 0)));
	check_f5 = _rowread(~((short)(1 << 0)));

	if ((key & RIGHT_KEY) && (player_x_update<timer)) { 
		if (dir==LEFT) {
			// This is added for updating the player animation...
			// Simply Erases the player-look-left sprite
			Sprite8_XOR(player_x, player_y, 16, player_left_dark, GetPlane (DARK_PLANE));
			Sprite8_XOR(player_x, player_y, 16, player_left_light, GetPlane (LIGHT_PLANE));
		  // And replace the right one
			Sprite8_XOR(player_x, player_y, 16, player_right_dark, GetPlane (DARK_PLANE));
			Sprite8_XOR(player_x, player_y, 16, player_right_light, GetPlane (LIGHT_PLANE));
					player_x_update=timer+10;
		}		
		if (dir==RIGHT)	player_x_speed++;
		if (player_x_speed>5) player_x_speed=5;
		dir = RIGHT;
	}

	if ((key & LEFT_KEY) && (player_x_update<timer)) {
		if (dir==RIGHT) {
			// This is added for updating the player animation...
			// Simply Erases the player-look-right sprite
			Sprite8_XOR(player_x, player_y, 16, player_right_dark, GetPlane (DARK_PLANE));
			Sprite8_XOR(player_x, player_y, 16, player_right_light, GetPlane (LIGHT_PLANE));
		  // And replace the left one
			Sprite8_XOR(player_x, player_y, 16, player_left_dark, GetPlane (DARK_PLANE));
			Sprite8_XOR(player_x, player_y, 16, player_left_light, GetPlane (LIGHT_PLANE));
					player_x_update=timer+10;
		}		
		if (dir==LEFT) player_x_speed--;
		if (player_x_speed<-5)player_x_speed=-5;
		dir = LEFT;
	}
// F1 Key
	if ((check_f1 & (1 << 4)) && (On_Ground())) {
		player_y_update=0;
		player_y_speed=28;
		jumpflag=1;
		temp=0;		
				while(temp<8) {
			SetPlane(DARK_PLANE);
			if (GetPix(player_x+temp,player_y-1)) jumpflag=0;
			SetPlane(LIGHT_PLANE);
			if (GetPix(player_x+temp,player_y-1)) jumpflag=0;
			temp++;
						}
		if(jumpflag) {
		beep(392,1); //Jumping
		beep(587,2);}
	}
/*
===============
Picking up / Placing Blocks...
Note that this part messes with the map array...
===============
*/
// F5 KEY
		if (check_f5 & (1 << 6)) {
		get_location(dir,map_height); // Get's mapx,mapy
		//Just a basic test for putting a placeable_block_dark/light
		if ((dir==1) && (map_array[mapy-1][mapx+1]!=1) && (timer>pblock_init)) {
			pblock_init=timer+50;
			if (map_array[mapy-1][mapx+1]==2) {
				Sprite8_XOR((mapx+1)*8, (mapy-map_height)*8, 8, placeable_block_dark, GetPlane (DARK_PLANE));
				Sprite8_XOR((mapx+1)*8, (mapy-map_height)*8, 8, placeable_block_light, GetPlane (LIGHT_PLANE));
				map_array[mapy-1][mapx+1]=0;
				blocks++;
				beep(294,1); //Picking up a block
				beep(349,2);
			} 
			else if ((map_array[mapy-1][mapx+1]==0) && (blocks>0)) {
				Sprite8_XOR((mapx+1)*8, (mapy-map_height)*8, 8, placeable_block_dark, GetPlane (DARK_PLANE));
				Sprite8_XOR((mapx+1)*8, (mapy-map_height)*8, 8, placeable_block_light, GetPlane (LIGHT_PLANE));
				map_array[mapy-1][mapx+1]=2;				
				blocks--;
				beep(330,1); //Placing a block
				beep(261,2);
			}
			Draw_HUD(blocks);
		}
		if ((dir==2) && (map_array[mapy-1][mapx-2]!=1) && (timer>pblock_init)) {
			pblock_init=timer+50;
			if (map_array[mapy-1][mapx-2]==2) {
				Sprite8_XOR((mapx-2)*8, (mapy-map_height)*8, 8, placeable_block_dark, GetPlane (DARK_PLANE));
				Sprite8_XOR((mapx-2)*8, (mapy-map_height)*8, 8, placeable_block_light, GetPlane (LIGHT_PLANE));
				map_array[mapy-1][mapx-2]=0;
				blocks++;
				beep(294,1); //Picking up a block
				beep(349,2);
			} 
			else if ((map_array[mapy-1][mapx-2]==0) && (blocks>0)) {
				Sprite8_XOR((mapx-2)*8, (mapy-map_height)*8, 8, placeable_block_dark, GetPlane (DARK_PLANE));
				Sprite8_XOR((mapx-2)*8, (mapy-map_height)*8, 8, placeable_block_light, GetPlane (LIGHT_PLANE));
				map_array[mapy-1][mapx-2]=2;				
				blocks--;
				beep(330,1); //Placing a block
				beep(261,2);
			}
			Draw_HUD(blocks);
		}
//		delay();
	}
		// ESC KEY
		if (check_esc & (1 << 0)) {
			// this is the Quit menu.. not realy nice, and only 2 options.. but it's far better than just
			// quitting without asking.. guess that would be anoying ;P
			temp=in_game_menu();	// 3 = quit, 2 = return to menu
			if (temp==3) return 1;
			if (temp==2) return 9; // for the menu..
		}
		//Malcolm's contrast functions
		if(_rowread(~((short)(1<<1))) & (1<<1)) {OSContrastUp();delayt(15000);}
		if(_rowread(~((short)(1<<1))) & (1<<2)) {OSContrastDn();delayt(15000);}

		key=0;
		check_f1=0;
		check_f5=0;
		check_esc=0;
}
	return 0;
	}
	
